'use strict'
var GOBJ = GOBJ || {};

var ctrl = angular.module('controllers', []);

ctrl.controller('menuCtrl', function ($scope) {});

ctrl.controller('homeCtrl', function ($scope, $state) {

  var op, tp, ea, ha, iw, ih, sr, jr, bk, c1, c2, bclick;

  angular.element(document).ready(function () {

    bclick = document.getElementById('buttonclick01');

    // find width of window...
    op = $('#home_view #op_butt')[0];
    tp = $('#home_view #tp_butt')[0];
    ea = $('#home_view #ea_butt')[0];
    ha = $('#home_view #ha_butt')[0];
    sr = $('#home_view #sr_butt')[0];
    jr = $('#home_view #jr_butt')[0];
    bk = $('#home_view #bk_butt')[0];
    iw = window.innerWidth;
    ih = window.innerHeight;

    move(op)
      .to(-iw)
      .duration('0s')
      .end();

    move(tp)
      .to(iw)
      .duration('0s')
      .end();

    move(ea)
      .to(iw)
      .duration('0s')
      .end();

    move(ha)
      .to(-iw)
      .duration('0s')
      .end();

    move(sr)
      .to(-iw)
      .duration('0s')
      .end();

    move(jr)
      .to(iw)
      .duration('0s')
      .end();

    move(bk)
      .to(0, ih)
      .duration('0s')
      .end();

    move(op)
      .ease('in')
      .x(0)
      .duration('0.5s')
      .delay('0.25s')
      .end();

    move(tp)
      .ease('in')
      .x(0)
      .duration('0.5s')
      .delay('0.25s')
      .end();

  });


  $scope.op_click = function () {
    bclick.play();
    move(op)
      .ease('in')
      .x(-iw)
      .duration('0.5s')
      .end();

    move(tp)
      .ease('in')
      .x(iw)
      .duration('0.5s')
      .end(function () {
        move(ha)
          .ease('in')
          .x(0)
          .duration('0.5s')
          .end();
        move(ea)
          .ease('in')
          .x(0)
          .duration('0.5s')
          .end();
        move(bk)
          .ease('in')
          .y(0)
          .duration('0.5s')
          .delay('0.25s')
          .end();

        c1 = ha;
        c2 = ea;
      });

  }
  $scope.tp_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    move(op)
      .ease('in')
      .x(-iw)
      .duration('0.5s')
      .end();

    move(tp)
      .ease('in')
      .x(iw)
      .duration('0.5s')
      .end(function () {
        move(sr)
          .ease('in')
          .x(0)
          .duration('0.5s')
          .end();
        move(jr)
          .ease('in')
          .x(0)
          .duration('0.5s')
          .end();
        move(bk)
          .ease('in')
          .y(0)
          .duration('0.5s')
          .delay('0.25s')
          .end();
        c1 = sr;
        c2 = jr;
      });
  }


  $scope.ha_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    GOBJ.board.dumbness = false;
    GOBJ.multiGame = false;
    GOBJ.board.startOver();
    $state.go('play');
  }

  $scope.ea_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    GOBJ.board.dumbness = true;
    GOBJ.multiGame = false;
    GOBJ.board.startOver();
    $state.go('play');
  }

  $scope.sr_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    GOBJ.multiGame = true;
    $state.go('start');
  }
  $scope.jr_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    GOBJ.multiGame = true;
    $state.go('join');
  }


  $scope.bk_click = function () {
    if (GOBJ.audioOn)
      bclick.play();

    move(c1)
      .ease('in')
      .x(-iw)
      .duration('0.5s')
      .end();

    move(c2)
      .ease('in')
      .x(iw)
      .duration('0.5s')
      .end();

    move(bk)
      .ease('in')
      .y(ih)
      .duration('0.5s')
      .end(function () {
        move(op)
          .ease('in')
          .x(0)
          .duration('0.5s')
          .delay('0.25s')
          .end();

        move(tp)
          .ease('in')
          .x(0)
          .duration('0.5s')
          .delay('0.25s')
          .end();
      });
  }

});

ctrl.controller('startCtrl', function ($scope, $state, siglr, settings) {

  // if here then muliplayer
  GOBJ.multiGame = true;

  $scope.data = {};
  var bclick, ui, pi, wt, iw, sr;

  angular.element(document).ready(function () {

    bclick = document.getElementById('buttonclick01');
    ui = $('#start_view #un_input')[0];
    pi = $('#start_view #pw_input')[0];
    wt = $('#start_view #wait_txt')[0];
    sr = $('#start_view #sr_butt')[0];


    iw = window.innerWidth;

    move(wt)
      .to(-iw)
      .duration('0s')
      .end();
  });

  $scope.sr_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    siglr.startRoom($scope.data.gname, $scope.data.pkey);
    move(ui)
      .ease('in')
      .x(iw)
      .duration('0.5s')
      .end();
    move(pi)
      .ease('in')
      .x(iw)
      .duration('0.5s')
      .end();
    move(sr)
      .ease('in')
      .x(iw)
      .duration('0.5s')
      .end();

  }

  $scope.bk_click = function () {
    if (GOBJ.audioOn)
    bclick.play();
    $state.go('home');
  }

  $scope.$on('roomStarted', function (e) {
    // we started a room - go look at the list of rooms

    // game starter is always player one
    GOBJ.multiPlayerNo = 1;

    $state.go('join');
  });

});

ctrl.controller('joinCtrl', function ($scope, $state, siglr, settings) {

  // if here then muliplayer
  GOBJ.multiGame = true;

  var bclick, dingding, rl, jr, iw, pi, pb, wt;

  // what go back does
  var gb_step = 1;

  $scope.data = {};
  $scope.selrooms = [];

  $scope.rooms = [{
    gname: 'Loading...'
  }];


  $scope.doRefresh = function () {
    siglr.getGamesWaiting();
  }

  $scope.$on('$ionicView.enter', function () {
    siglr.getGamesWaiting();
  });

  // $scope.$on('ready', function (e) {
  //   siglr.getGamesWaiting();
  // });

  $scope.$on('gamesWaiting', function (e, games) {
    if (games.length)
      $scope.rooms = games;
    else
      $scope.rooms[0].gname = 'No Games...';

    $scope.$broadcast('scroll.refreshComplete');
    $scope.$apply();

  });

  $scope.$on('playerLeft', function (e, gname, pcount) {
    for (var i = 0, l = $scope.rooms.length; i < l; i++) {
      var game = $scope.rooms[i];
      if (game.gname == gname) {
        game.pcount = pcount;
        $scope.$apply();
        break;
      }
    }

  });


  // other player joined room - or could have started room
  $scope.$on('playerJoined', function (e, gname, has_pkey, pcount) {
    var fnd = false;

    if ($scope.rooms[0].gname == 'No Games...')
      $scope.rooms.length = 0;


    for (var i = 0, l = $scope.rooms.length; i < l; i++) {
      var game = $scope.rooms[i];
      if (game.gname == gname) {
        game.pcount = pcount;

        fnd = true;
        break;
      }
    }

    if (!fnd) { // room not found so add it
      $scope.rooms.push({
        gname: gname,
        has_passkey: has_pkey,
        pcount: 1
      });
    }
    $scope.$apply();

  });

  angular.element(document).ready(function () {
    bclick = document.getElementById('buttonclick01');
    dingding = document.getElementById('dingding');
    iw = window.innerWidth;

    rl = $('#join_view #room_list')[0];
    jr = $('#join_view #jr_butt')[0];
    pi = $('#join_view #pw_input')[0];
    pb = $('#join_view #pw_butt')[0];

    move(pi)
      .to(-iw)
      .duration('0s')
      .end();
    move(pb)
      .to(-iw)
      .duration('0s')
      .end();

  });

  $scope.jr_click = function () {
    if (GOBJ.audioOn)
    bclick.play();

    // here we are going to do different things depending on how many people are in the room
    // two - start the game
    // one - wait
    // password protected.. present the pw input

    var jgame = $scope.selrooms[0];

    if (jgame.has_passkey) {
      gb_step = 2;
      move(rl)
        .ease('in')
        .x(iw)
        .duration('0.5s')
        .end();
      move(jr)
        .ease('in')
        .x(iw)
        .duration('0.5s')
        .end();

      move(pi)
        .ease('in')
        .x(0)
        .duration('0.5s')
        .end();
      move(pb)
        .ease('in')
        .x(0)
        .duration('0.5s')
        .end();
    } else {
      // no passkey
      // join room
      siglr.joinRoom(jgame.gname);

    }

  }

  $scope.pw_click = function () {
    // room has passkey
    // passkey was entered.
    var jgame = $scope.selrooms[0];
    siglr.joinRoom(jgame.gname, $scope.data.pkey);

  }

  $scope.$on('roomJoined', function (e, gname, pcount) {

    //this player joined room, password was accepted
    GOBJ.multiPlayerNo = pcount;

    var fgame;

    for (var i = 0, l = $scope.rooms.length; i < l; i++) {
      if ($scope.rooms[i].gname == gname) {
        fgame = $scope.rooms[i];
        break;
      }
    }

    if (fgame) {

      fgame.you_here = true;
      fgame.pcount = pcount;

      if (pcount == 2) { // game has now two players..go play
        siglr.startGame(gname);
      } else if (pcount == 1) { // game has one player .. wait

        // move password stuff out of the way
        move(pi)
          .ease('in')
          .x(-iw)
          .duration('0.5s')
          .end();
        move(pb)
          .ease('in')
          .x(-iw)
          .duration('0.5s')
          .end();

      } else {
        console.log('Invalid Player Count in Game');
      }

      $scope.$apply();

    }

  });

  $scope.$on('gameStarted', function (e, gname, firstp) {
    GOBJ.gname = gname;
    GOBJ.youFirst = (GOBJ.multiPlayerNo == firstp);
    if (GOBJ.audioOn)
      dingding.play();
    $state.go('play');
  });

  $scope.inroom = function () {
    if ($scope.selrooms.length)
      if ($scope.selrooms[0].you_here)
        return true;

    return false;

  }
  $scope.canjoin = function () {
    // cant join a room if you are in a room
    for (var i = 0, l = $scope.rooms.length; i < l; i++) {
      if ($scope.rooms[i].you_here) {
        return false;
      }
    }

    if ($scope.selrooms.length)
      if ($scope.selrooms[0].pcount < 2)
        return true;

    return false;
  }

  // leave a room
  $scope.lv_click = function () {
    if (GOBJ.audioOn)
      bclick.play();
    if ($scope.selrooms.length) {
      var lroom = $scope.selrooms[0];
      if (lroom.you_here) {
        siglr.leaveRoom(lroom.gname);
      }
    }
  }

  // this player left a room
  $scope.$on('roomLeft', function (e, gname, pcount) {
    for (var i = 0, l = $scope.rooms.length; i < l; i++) {
      if ($scope.rooms[i].gname == gname) {
        var fgame = $scope.rooms[i];
        fgame.you_here = false;
        fgame.pcount = pcount;
        $scope.$apply();
        break;
      }
    }
  });


  // go back to previous menu
  $scope.bk_click = function () {
    if (GOBJ.audioOn)
      bclick.play();

    if (gb_step == 1) { // go home
      // see if player has joined any room and exit them
      for (var i = 0, l = $scope.rooms.length; i < l; i++) {
        var game = $scope.rooms[i];
        if (game.you_here) {
          siglr.leaveRoom(game.gname);
          game.you_here = false;
          //game.pcount -= 1;
          break;
        }
      }

      $state.go('home');

    } else { // remove password stuff
      move(rl)
        .ease('in')
        .x(0)
        .duration('0.5s')
        .end();
      move(jr)
        .ease('in')
        .x(0)
        .duration('0.5s')
        .end();

      move(pi)
        .ease('in')
        .x(-iw)
        .duration('0.5s')
        .end();
      move(pb)
        .ease('in')
        .x(-iw)
        .duration('0.5s')
        .end();
      gb_step = 1;
    }
  }

});


ctrl.controller('playCtrl', function ($scope, $state,
  $ionicPopup, $location, siglr) {
  $scope.data = {};
  $scope.goHome = function () {

    var confirmPopup = $ionicPopup.confirm({
      title: 'Hey...',
      template: 'Are you sure you want to quit the game?'
    });
    confirmPopup.then(function (res) {
      if (res) {
        if (GOBJ.multiGame) {
          siglr.leaveRoom(GOBJ.gname);
          $state.go('join');
        } else {
          $state.go('home');
        }
      }
    });
  }

  $scope.goChat = function () {
    $scope.data.chattxt = '';
    var myPopup = $ionicPopup.show({
      template: '<input type="text" ng-model="data.chattxt">',
      title: 'Say Something...',
      scope: $scope,
      buttons: [
        {
          text: 'Cancel'
        },
        {
          text: '<b>Ok</b>',
          type: 'button-positive',
          onTap: function (e) {
            if ($scope.data.chattxt) {
              return $scope.data.chattxt;
            }
          }
      }
    ]
    });
    myPopup.then(function (res) {
      siglr.sayChat(GOBJ.gname, res, GOBJ.multiPlayerNo);
      GOBJ.game.state.states.level.paintChat(res, GOBJ.multiPlayerNo);
    });
  }

  $scope.goIAP = function () {
    if (!GOBJ.ads_on){
      $ionicPopup.alert({
        title: 'Ad Removal',
        template: 'You have already removed ads from this game. Enjoy!'
      });        
    }else{
      var buyAdRmvPopup = $ionicPopup.confirm({
        title: 'Ad Removal',
        template: 'If you would like to remove ads from this game for a small fee of '+GOBJ.ads_price+', please click the Remove Ads button.',
        buttons: [
          {
            text: 'Cancel'
          },
          {
            text: '<b>Remove Ads</b>',
            type: 'button-balanced',
            onTap: function(){
              return true;
            }
        }]
      });
      buyAdRmvPopup.then(function (res) {
        if (res) {            
            store.order('four_across_ad_removal');
        }    
      });   
    } 
  }

  $scope.movePiece = function (col) {
    siglr.movePiece(GOBJ.gname, col);
  }


  $scope.$on('pieceMoved', function (e, col) {
    GOBJ.game.state.states.level.oppPiece(col);
  });

  $scope.$on('listenChat', function (e, txt, pno) {
    GOBJ.game.state.states.level.paintChat(txt, pno);
  });

  $scope.$on('playerLeft', function (e, gname) {
    // opponent left the game
    GOBJ.game.state.states.level.oppLeft();

    // you become player one
    GOBJ.multiPlayerNo = 1;

    var leftAlert = $ionicPopup.alert({
      title: 'Whoops...',
      template: 'Opponent left the Game!'
    });
    leftAlert.then(function () {
      $state.go('join');
    });
  });

  $scope.askPlayAgain = function () {
    siglr.askPlayAgain(GOBJ.gname);
  }
  $scope.$on('askedPlayAgain', function (e) {
    GOBJ.game.state.states.level.playagainclear();
    var confirmPopup = $ionicPopup.confirm({
      title: 'Hey...',
      template: 'Your opponent is asking if you want to play again?',
      okText: 'Sure',
      cancelText: 'No Thanks'
    });
    confirmPopup.then(function (res) {
      siglr.respondPlayAgain(GOBJ.gname, res);
      if (res) {
        // start over
        GOBJ.game.state.states.level.multiAgain();
      } else {
        // leave the game
        siglr.leaveRoom(GOBJ.gname);
        $state.go('join');
      }

    });
  });

  $scope.$on('respondedPlayAgain', function (e, resp) {
    if (resp) {
      // start over
      GOBJ.game.state.states.level.multiAgain();
    } else {
      // leave the game
      siglr.leaveRoom(GOBJ.gname);
      $state.go('join');
    }
  });

});
