'use strict'
var GOBJ = GOBJ || {};

GOBJ.preload = function () {
  var self = this;

  self.preload = function () {
    self.game.load.image('redp', 'img/redp.png');
    self.game.load.image('blackp', 'img/blackp.png');
    self.game.load.image('room', 'img/room2.png');
    self.game.load.image('gameboard', 'img/gameboardvert.png');
    self.game.load.image('holder', 'img/holder.png');

    self.game.load.spritesheet('playagainbtn', 'img/playagain2.png', 164, 56);
    self.game.load.spritesheet('homebtn', 'img/homeicon.png', 60, 60);
    self.game.load.spritesheet('audiobtn', 'img/audioicon.png', 60, 60);
    self.game.load.spritesheet('restartbtn', 'img/restarticon.png', 60, 60);
    self.game.load.spritesheet('chatbtn', 'img/chatbutton.png', 60, 60);
    self.game.load.spritesheet('infobtn', 'img/info.png', 60, 60);

    self.game.load.audio('clack01', 'mp3/clack01.mp3');
    self.game.load.audio('clack03', 'mp3/clack03.mp3');
    self.game.load.audio('buttonclick01', 'mp3/buttonclick01.mp3');
    self.game.load.audio('drone01', 'mp3/drone01.mp3');
    self.game.load.audio('hallelujah', 'mp3/hallelujah.mp3');
    self.game.load.audio('hit02', 'mp3/hit02.mp3');
    self.game.load.audio('kershluck01', 'mp3/kershluck01.mp3');
    self.game.load.audio('whawha', 'mp3/whawha.mp3');
    self.game.load.audio('ding', 'mp3/ding.mp3');
    self.game.load.audio('fart', 'mp3/fart.mp3');

  }

  self.create = function () {
    GOBJ.game.state.start('level');
  }

}
