'use strict'
// global namespace
var GOBJ = GOBJ || {};

GOBJ.createGame = function(scope, injector) {
  GOBJ.window_width = window.innerWidth;
  GOBJ.window_height = window.innerHeight;
    // Build the game object
  var width  = 320;
  var height  = 568;

  GOBJ.game = new Phaser.Game(GOBJ.window_width, 
                              GOBJ.window_height, 
                              Phaser.AUTO, 'gameCanvas');

  GOBJ.injector = injector;
  GOBJ.scope = scope;

  GOBJ.game.state.add('boot', GOBJ.boot);
  GOBJ.game.state.add('preload', GOBJ.preload);
  GOBJ.game.state.add('level', GOBJ.level);

  GOBJ.game.state.start('boot');

};
